/************************************************
*	DSDEBUG.H - equates used by ALL the data	*
*	structure toolbox functions.				*
************************************************/

#ifndef DS_NODEBUG
/***** Status returned by most ds?? routines ****/
typedef enum tag_dsStat
	{
	dssOK 		=0,			/* No error			*/
	dssNOMEM,				/* Ran out of RAM	*/
	dssBADMEM,				/* Bad block list	*/
	dssBADHANDLE,			/* Incorrect Handle	*/
	dssBADCHECK,			/* ALLOC check error*/
	dssBADREQ				/* Bad Request		*/
	} dsStat;

/***** Operation modes for dsAcheck, dsValid ****/
typedef enum tag_dsChecks
	{
	dcCHECK,		/* Check if block is valid	*/
	dcRESET,		/* Make block invalid		*/
	dcSET			/* Make block valid			*/
	} dsChecks;

/*Function prototypes for data structure toolbox*/
dsStat	   far dsAdump(FILE *);
void far * far dsCalloc(size_t, size_t);
dsStat	   far dsFree(void far *);
dsStat	   far dsLastError(void);
void far * far dsMalloc(size_t);
void far * far dsRealloc(void far *, size_t);
dsStat	   far dsValid(void far *, char *, FILE *);

#ifndef IN_SOURCE_DSALLOC
#	define calloc(x,y)		dsCalloc(x,y)
#	define free(x)			dsFree(x)
#	define malloc(x)		dsMalloc(x)
#	define realloc(x,y)		dsRealloc(x,y)
#endif

/*** Defines controlling how the toolbox works **/

#define MAXCORR 10	/* Max # bad blocks that may*/
					/* be in list, before it is	*/
					/* declared to be a BAD LIST*/

#else	/* Turn debugging off .. don't call the	*/
#	define dsAdump(x)	1	/* special debug	*/
#	define dsLastError	0	/* functions		*/
#	define dsValid		0
#endif

#define fNULL ((void far *)0L)
