/************************************************
* KBSETUP - set the desired delay/repeat rate	*
* for the keyboard.								*
*												*
* With no arguments, it speeds up the keyboard	*
* to the fastest possible rate.					*
************************************************/

#include <ctype.h>	/* isdigit, tolower			*/
#include <dos.h>	/* int86					*/
#include <stdio.h>
#include <stdlib.h>
#define ISIN(l,h,v) ((l<=v)&&(v<=h))
int kbdelay=0,		/* Default typematic delay	*/
	kbrepeat=0;		/* Default repeat rate		*/

void usage(void)
	{
	puts("KBSETUP ERROR: there are only allowed "
		 "to be two types of parameters.\nA, B, "
		 "C or D will set the delay before repea"
		 "ting to 1/4, 1/2, 3/4 and 1 second,\nR"
		 "espectively.  The numbers from 0..31 s"
		 "et the repeat rate of the keyboard.");
	exit(1);
	}

void main(int argc, char *argv[])
	{
	int i;
	union REGS r;

	/* Process the arguments */
	for (i=1; i<argc; ++i)
		if (isdigit(*argv[i]))	/* repeat rate	*/
			{
			kbrepeat=atoi(argv[i]);
			if (!ISIN(0,31,kbrepeat))
				usage();
			}
		else				/* delay before rpt	*/
			{
			argv[i][0]=toupper(argv[i][0]);
			if (!ISIN('A','D',argv[i][0]))
				usage();
			kbdelay=argv[i][0]-'A';
			}

	/* Set the keyboard delay/repeat rate */
	r.x.ax = 0x0305;
	r.h.bh = kbdelay;
	r.h.bl = kbrepeat;
	int86(0x16,&r,&r);
	}
