/* popupmsg.c - uses the POPUP screen group to
 *				display a pop-up message.
 */

#define INCL_VIO
#define INCL_DOS
#include<os2.h>
#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<string.h>
#include<ctype.h>
#include<conio.h>

#define VIOHDL  0

char *usage =
    "Usage: POPUPMSG <mm/dd/yy[yy]> <hh:mm:ss> "
    "<interval> [/f]<msg>\n";

DATETIME dt,dt2;
void error_exit(USHORT errcode, char *fmt,...);

void main(int argc, char **argv)
    {
	USHORT wait = (VP_WAIT | VP_OPAQUE);
    char temp[7], *p, *msg, buf[81];
    ULONG interval,*ymd,*ymd2;
    USHORT msgfile = FALSE;
    FILE *fp;

    if(argc != 5)               /* check args  */
        error_exit(0,usage);

        /* initialize temp and dt   */
    memset(temp,'\0',sizeof(temp));
    memset(&dt,'\0',sizeof(dt));
    temp[2] = '\0';                 

    p = argv[1];                /* get mm/dd/yy*/
    memcpy(temp,p,2);
    dt.month = (UCHAR)atoi(temp);

    p += 3;
    memcpy(temp,p,2);
    dt.day = (UCHAR)atoi(temp);

    p += 3;
    strcpy(temp,p);
    dt.year = atoi(temp);
    if(dt.year < 1900)
        dt.year += 1900;

    memset(temp,'\0',sizeof(temp));
    p = argv[2];                /* get hh/mm/ss*/
    memcpy(temp,p,2);
    dt.hours = (UCHAR)atoi(temp);

    p += 3;
    memcpy(temp,p,2);
    dt.minutes = (UCHAR)atoi(temp);

    p += 3;
    memcpy(temp,p,2);
    dt.seconds = (UCHAR)atoi(temp);

    interval = atol(argv[3]);   /* get interval*/
    interval *= 1000L;     /* convert to msecs */

    p = argv[4];
    if(*p == '/' && (toupper(p[1]) == 'F'))
        {
        msgfile = TRUE;
        msg = &p[2];
        }
    else
        msg = p;

    dt.timezone = -1;
    dt2 = dt;               /* structure assign */
    ymd = (ULONG *)&dt.day; /* set long ptrs    */
    ymd2 = (ULONG *)&dt2.day;

    /* stay in loop until date/time are reached
       (or exceeded) by sleeping for interval
       milliseconds, then checking date/time
     */
    while(TRUE)
        {
        DosGetDateTime(&dt);
        dt2.hundredths = 0;
    /* if year-month-day > year-month-day2 or
       if year-month-day are equal AND
           (hours are greater OR
           (hours are equal AND
           (minutes are greater OR
           (minutes are equal AND
               seconds greater))))
     */
        if(*ymd > *ymd2 ||
          (*ymd == *ymd2 &&
              (dt.hours > dt2.hours ||
              (dt.hours == dt2.hours &&
                  (dt.minutes > dt2.minutes ||
                  (dt.minutes == dt2.minutes &&
                  dt.seconds > dt2.seconds))))))
            {
            VioPopUp(&wait,VIOHDL);
            if(!msgfile)
                printf(msg);
            else
                {
                if(!(fp = fopen(msg,"rt")))
                    printf("POPUPMSG: Error: "
                        "Unable to open Message "
                        "file!");
                else
                    {
                    while(
                        fgets(buf,sizeof(buf),fp))
                        printf(buf);
                    fclose(fp);
                    }
                }
            printf("\nPress a key to continue.");

            getch();
            VioEndPopUp(VIOHDL);
            break;
            }
        DosSleep(interval);
        }
    DosExit(0,EXIT_PROCESS);
    }

void error_exit(USHORT errcode, char *fmt,...)
    {
    va_list argptr;
    va_start(argptr,fmt);
    vprintf(fmt,argptr);
    va_end(argptr);

    DosExit(errcode,EXIT_PROCESS);
    }
